/*
   Copyright (C) 2002 Dylan Yudaken(d_yud@hotmail.com)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.
*/

#include "common.h"
int	done=FALSE;								// Bool Variable To Exit Loop
int isActive;
int MainLoop()
{
	static Uint32 oldtime;
	Uint32 newtime;
	SDL_Event event;
	
	oldtime = SDL_GetTicks();

	//Initialise all systems
    if ( SDL_Init(	SDL_INIT_NOPARACHUTE | 
					SDL_INIT_EVENTTHREAD |
					SDL_INIT_TIMER ) < 0 )
	{
	    fprintf( stderr, "SDL initialization failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}
	if (GL.CreateGLWindow("3D Test",Width,Height,16,fullscreen) != 1)
	{
	    fprintf( stderr, "Video initialization failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}
	if (!Sound.Init())
	{
	    fprintf( stderr, "Sound initialization failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}
	InitGame();		//Load sounds,textures...
	while(!done){
		while ( SDL_PollEvent( &event ) )	//check events
		{
		    switch( event.type )
			{
			case SDL_ACTIVEEVENT:
			    if ( event.active.gain == 0 )
				isActive = FALSE;
			    else
				isActive = TRUE;
			    break;
			case SDL_VIDEORESIZE:
			    /* handle resize event */
			    GL.surface = SDL_SetVideoMode( event.resize.w,
							event.resize.h,
							16, GL.videoFlags );
			    if ( !GL.surface )
				{
				    fprintf( stderr, "Could not get a surface after resize: %s\n", SDL_GetError( ) );
				    Quit( 1 );
				}
			    GL.ReSizeGLScene( event.resize.w, event.resize.h );
			    break;
			case SDL_KEYDOWN:
			    /* handle key presses */
			    keys[event.key.keysym.sym] = TRUE;
			    break;
			case SDL_KEYUP:
			    /* handle key presses */
			    keys[event.key.keysym.sym] = FALSE;
			    break;
			case SDL_QUIT:
			    /* handle quit requests */
			    done = TRUE;
			    break;
			default:
			    break;
			}
		}
		newtime = SDL_GetTicks();
		ticktime = newtime - oldtime;
		oldtime = newtime;
		DrawGLScene();
		
	}

	// Shutdown
	GL.KillGLWindow();									// Kill The Window
	return (1);							// Exit The Program

}
void Quit(int n)
{
	fprintf(stderr,"Quitting with error code %d",n);
	SDL_Quit();
}
