/*
   Copyright (C) 2002 Dylan Yudaken(d_yud@hotmail.com)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.
*/

#include "common.h"
void CLog::InitLog()
{
    time_t t               = time(NULL);        // Get Current Time
    struct tm *time         = localtime(&t);     // Convert to Local Time

	if(filename == NULL) filename = LOGFILE;
	switch(type){
		case LOG_NEW:
			logfile = fopen(filename,"w");
		case LOG_NEW_DATE:
			logfile = fopen(filename,"w");
		case LOG_APPEND:
			logfile = fopen(filename,"a");
		case LOG_APPEND_DATE:
			logfile = fopen(filename,"a");
		default:
			logfile = fopen(filename,"w");
	}
    Plog(this,"Logging Started at : %02d/%02d/%04d %02d:%02d:%02d\n*\t*\t*\t\n", time->tm_mon + 1, time->tm_mday, time->tm_year + 1900, time->tm_hour, time->tm_min, time->tm_sec);

}
void Plog(CLog *Log, const char *fmt, ...)	// Where The Printing Happens
{
	char		text[256];									// Holds Our String
	va_list		ap;											// Pointer To List Of Arguments

	if (fmt == NULL)										// If There's No Text
		return;												// Do Nothing
	va_start(ap, fmt);										// Parses The String For Variables
	    vsprintf(text, fmt, ap);							// And Converts Symbols To Actual Numbers
	va_end(ap);												// Results Are Stored In Text
	fprintf(Log->logfile,text);

}
void Pflog(CLog *Log, const char *fmt, ...)	// Where The Printing Happens
{
	char		text[256];									// Holds Our String
	va_list		ap;											// Pointer To List Of Arguments

	if (fmt == NULL)										// If There's No Text
		return;												// Do Nothing
	va_start(ap, fmt);										// Parses The String For Variables
	    vsprintf(text, fmt, ap);							// And Converts Symbols To Actual Numbers
	va_end(ap);												// Results Are Stored In Text
	fprintf(Log->logfile,text);
	fflush(Log->logfile);

}

void Plog(const char *fmt, ...)	// Where The Printing Happens
{
	char		text[256];									// Holds Our String
	va_list		ap;											// Pointer To List Of Arguments

	if (fmt == NULL)										// If There's No Text
		return;												// Do Nothing
	va_start(ap, fmt);										// Parses The String For Variables
	    vsprintf(text, fmt, ap);							// And Converts Symbols To Actual Numbers
	va_end(ap);												// Results Are Stored In Text
	fprintf(Log.logfile,text);

}
void Pflog(const char *fmt, ...)	// Where The Printing Happens
{
	char		text[256];									// Holds Our String
	va_list		ap;											// Pointer To List Of Arguments

	if (fmt == NULL)										// If There's No Text
		return;												// Do Nothing
	va_start(ap, fmt);										// Parses The String For Variables
	    vsprintf(text, fmt, ap);							// And Converts Symbols To Actual Numbers
	va_end(ap);												// Results Are Stored In Text
	fprintf(Log.logfile,text);
	fflush(Log.logfile);

}
CLog::Clog(char *filename,LogType type)
{
	filename = filename;
	type = type;
}
	
	